import { world } from '@minecraft/server';

// Fungsi untuk memainkan suara klik
function playClickSound(block, soundName) {
    block.dimension.playSound(soundName, block.location);
}

world.beforeEvents.worldInitialize.subscribe(eventData => {
    // Komponen untuk 'hwk:interactive_1'
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_1', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:channel') ?? 0; // Gunakan 0 jika state undefined

            if (currentState < 4) {
                block.setPermutation(permutation.withState('hwk:channel', currentState + 1)); // Ubah state channel
            } else if (currentState === 4) {
                block.setPermutation(permutation.withState('hwk:channel', 0)); // Reset state channel jika sudah mencapai 4
            }

            playClickSound(block, "random.click"); // Panggil fungsi suara klik
        }
    });

    // Komponen untuk 'hwk:interactive_0'
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_0', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "block.barrel.open"); // Panggil fungsi suara klik
        }
    });

    // Komponen untuk 'hwk:interactive_2' (digital clock)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_2', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "digital.alarm"); // Panggil fungsi suara dengan suara digital.alarm
        }
    });

    // Komponen untuk 'hwk:interactive_3' (classic clock)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_3', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "classic.alarm"); // Panggil fungsi suara dengan suara digital.alarm
        }
    });
    // Komponen untuk 'hwk:interactive_4' (Laptop Startup)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_4', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "laptop.startup"); // Panggil fungsi suara dengan suara digital.alarm
        }
    });
    // Komponen untuk 'hwk:interactive_5' (Random.Click)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_5', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "random.click"); // Panggil fungsi suara dengan suara digital.alarm
        }
    });
    // component ('hwk:sit')
    // Fungsi untuk membuat pemain duduk
    function sitOnBlock(block, player) {
        const seatEntity = block.dimension.spawnEntity("hwk:sit", { x: block.x + 0.5, y: block.y + 0.5, z: block.z + 0.5 });

        if (seatEntity) {
            let component = seatEntity.getComponent("minecraft:rideable")
            if (component === undefined) return
            component.addRider(player);
        }
    }


    eventData.blockComponentRegistry.registerCustomComponent('hwk:sit', {
        onPlayerInteract(e) {
            const { block, player } = e;
            sitOnBlock(block, player);
        }
    });
    // Komponen untuk 'hwk:interactive_6' (membutuhkan sneak untuk mengubah blok permutationnya!)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_6', {
        onPlayerInteract(e) {
            const { block, player } = e;

            // Cek apakah pemain sedang sneak
            if (!player.isSneaking) {
                return; // Jika tidak sneak, tidak melakukan apa-apa
            }

            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:blockin') ?? 0; // Gunakan 0 jika state undefined

            if (currentState < 1) {
                block.setPermutation(permutation.withState('hwk:blockin', currentState + 1)); // Ubah state channel
            } else if (currentState === 1) {
                block.setPermutation(permutation.withState('hwk:blockin', 0)); // Reset state channel jika sudah mencapai 1
            }

            playClickSound(block, "dig.powder_snow"); // Panggil fungsi suara klik
        }
    });
    // Komponen untuk 'hwk:interactive_7' (Bell Sound)
    eventData.blockComponentRegistry.registerCustomComponent('hwk:interactive_7', {
        onPlayerInteract(e) {
            const { block } = e;
            const permutation = block.permutation; // Simpan permutation dalam variabel lokal
            const currentState = permutation.getState('hwk:on') ?? false; // Gunakan false jika state undefined
            const newOpenState = !currentState; // Membalik nilai true/false

            // Perbarui status blok
            block.setPermutation(permutation.withState('hwk:on', newOpenState));

            playClickSound(block, "hwk.bellsound"); // Panggil fungsi suara dengan suara digital.alarm
        }
    });
});