import { world } from "@minecraft/server";

// Fungsi untuk memainkan suara klik
function playClickSound(block, soundName) {
    block.dimension.playSound(soundName, block.location);
}

//Screwdriver - Hawk Tool
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('hwk:screwdriver', {
        onPlayerInteract(e) {
            const { block, player } = e;

            // Cek item di tangan pemain
            const inventory = player.getComponent("minecraft:inventory");
            const container = inventory?.container;
            const item = container?.getItem(player.selectedSlotIndex);

            if (!item || item.typeId !== "hwk:screwdriver") {
                return; // Jika bukan screwdriver, tidak melakukan apa-apa
            }

            const permutation = block.permutation;
            const currentState = parseInt(permutation.getState('hwk:tool_1')) || 0;

            if (currentState < 2) {
                block.setPermutation(permutation.withState('hwk:tool_1', currentState + 1));
            } else {
                block.setPermutation(permutation.withState('hwk:tool_1', 0));
            }

            playClickSound(block, "dig.powder_snow");
        }
    });
});